unit Unit1;

interface

{$IFDEF VCL}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
{$ELSE}
uses
  SysUtils, Classes, WQ, QGraphics, QControls,
  QForms, QStdCtrls, QMenus, QDialogs;
{$ENDIF}


type
  TForm1 = class(TForm)
    edtText: TEdit;
    lblText: TLabel;
    lblMouseAction: TLabel;
    btnClear: TButton;
    btnText: TButton;
    btnEnabled: TButton;
    btnVisible: TButton;
    btnSize: TButton;
    btnPosition: TButton;
    lblLeft: TLabel;
    edtLeft: TEdit;
    lblHeight: TLabel;
    edtTop: TEdit;
    lblTop: TLabel;
    lblWidht: TLabel;
    edtWidth: TEdit;
    edtHeight: TEdit;
    btnAutoSize: TButton;
    btnHideSelection: TButton;
    Edit1: TEdit;
    btnAutoSelect: TButton;
    btnCharCase: TButton;
    btnEchoMode: TButton;
    btnSelect: TButton;
    lblStart: TLabel;
    edtSelStart: TEdit;
    lblLength: TLabel;
    edtSelLength: TEdit;
    lblSelText: TLabel;
    edtSelText: TEdit;
    btnSelGet: TButton;
    btnSelSet: TButton;
    btnSelectAll: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1Click(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnTextClick(Sender: TObject);
    procedure btnEnabledClick(Sender: TObject);
    procedure btnVisibleClick(Sender: TObject);
    procedure btnSizeClick(Sender: TObject);
    procedure btnPositionClick(Sender: TObject);
    procedure btnAutoSizeClick(Sender: TObject);
    procedure btnHideSelectionClick(Sender: TObject);
    procedure btnAutoSelectClick(Sender: TObject);
    procedure btnCharCaseClick(Sender: TObject);
    procedure btnEchoModeClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure btnSelGetClick(Sender: TObject);
    procedure btnSelSetClick(Sender: TObject);
    procedure btnSelectClick(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BorderStyle := fbsDialog;
  edtLeft.Text := IntToStr(Edit1.Left);
  edtTop.Text := IntToStr(Edit1.Top);
  edtWidth.Text := IntToStr(Edit1.Width);
  edtHeight.Text := IntToStr(Edit1.Height);
end;

procedure TForm1.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + '[';
end;

procedure TForm1.Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + '.';
end;

procedure TForm1.Edit1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + ']';
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + 'O';
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  lblMouseAction.Caption := '';
end;

procedure TForm1.btnTextClick(Sender: TObject);
begin
  Edit1.Text := edtText.Text;
end;

procedure TForm1.btnEnabledClick(Sender: TObject);
begin
  Edit1.Enabled := not Edit1.Enabled;
end;

procedure TForm1.btnVisibleClick(Sender: TObject);
begin
  Edit1.Visible := not Edit1.Visible;
end;

procedure TForm1.btnSizeClick(Sender: TObject);
begin
  Edit1.Width := StrToInt(edtWidth.Text);
  Edit1.Height := StrToInt(edtHeight.Text);
  edtWidth.Text := IntToStr(Edit1.Width);
  edtHeight.Text := IntToStr(Edit1.Height);
end;

procedure TForm1.btnPositionClick(Sender: TObject);
begin
  Edit1.Left := StrToInt(edtLeft.Text);
  Edit1.Top := StrToInt(edtTop.Text);
  edtLeft.Text := IntToStr(Edit1.Left);
  edtTop.Text := IntToStr(Edit1.Top);
end;

procedure TForm1.btnAutoSizeClick(Sender: TObject);
begin
  Edit1.AutoSize := not Edit1.AutoSize;
end;

procedure TForm1.btnHideSelectionClick(Sender: TObject);
begin
  Edit1.HideSelection := not Edit1.HideSelection;
end;

procedure TForm1.btnAutoSelectClick(Sender: TObject);
begin
  Edit1.AutoSelect := not Edit1.AutoSelect;
end;

procedure TForm1.btnCharCaseClick(Sender: TObject);
var
  CharCase: TEditCharCase;
begin
  CharCase := Edit1.CharCase;
  if CharCase = High(TEditCharCase) then
    CharCase := Low(TEditCharCase)
  else
    Inc(CharCase);
  Edit1.CharCase := CharCase;
end;

procedure TForm1.btnEchoModeClick(Sender: TObject);
var
  EchoMode: TEchoMode;
begin
  EchoMode := Edit1.EchoMode;
  if EchoMode = High(TEchoMode) then
    EchoMode := Low(TEchoMode)
  else
    Inc(EchoMode);
  Edit1.EchoMode := EchoMode;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + 'c';
end;

procedure TForm1.btnSelGetClick(Sender: TObject);
begin
  edtSelText.Text := Edit1.SelText;
end;

procedure TForm1.btnSelSetClick(Sender: TObject);
begin
  Edit1.SelText := edtSelText.Text;
end;

procedure TForm1.btnSelectClick(Sender: TObject);
begin
  Edit1.SelStart := StrToInt(edtSelStart.Text);
  Edit1.SelLength := StrToInt(edtSelLength.Text);
end;

procedure TForm1.btnSelectAllClick(Sender: TObject);
begin
  Edit1.SelectAll;
end;

end.

