unit frmuMain;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, DwpLptCtrls;

type
  TfrmMain = class(TForm)
    edtData: TEdit;
    btnSetData: TButton;
    btnOpen: TButton;
    btnClose: TButton;
    Label1: TLabel;
    cbxDevice: TComboBox;
    Label2: TLabel;
    edtCtrl: TEdit;
    Label3: TLabel;
    btnSetCtrl: TButton;
    btnGetStatus: TButton;
    Label4: TLabel;
    edtStatus: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnSetDataClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnSetCtrlClick(Sender: TObject);
    procedure btnGetStatusClick(Sender: TObject);
  private
    { Private-Deklarationen }
    LptCtrl1: TdwpLptCtrl;
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.xfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  I: TLptDevice;
begin
  LptCtrl1 := TdwpLptCtrl.Create(Self);
  for I := Low(TLptDevice) to High(TLptDevice) do
    cbxDevice.Items.Add(LptDeviceNames[I]);
  cbxDevice.ItemIndex := 0;
end;

procedure TfrmMain.btnSetDataClick(Sender: TObject);
begin
  LptCtrl1.Data := StrToInt(edtData.Text);
end;

procedure TfrmMain.btnOpenClick(Sender: TObject);
begin
  LptCtrl1.Device := TLptDevice(cbxDevice.ItemIndex);
  LptCtrl1.Open;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  LptCtrl1.Close;
end;

procedure TfrmMain.btnSetCtrlClick(Sender: TObject);
begin
  LptCtrl1.Ctrl := StrToInt(edtCtrl.Text);
end;

procedure TfrmMain.btnGetStatusClick(Sender: TObject);
var
  Status: Byte;
begin
  Status := LptCtrl1.Status;
  edtStatus.Text := Format('$%0.2x (%d)', [Status, Status]);
end;

end.
