unit MMO1Main;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QMenus;

type
  TForm1 = class(TForm)
    btnAppend: TButton;
    Memo1: TMemo;
    edtText: TEdit;
    btnAtEOF: TButton;
    btnClearEvents: TButton;
    lblEvents: TLabel;
    btnClear: TButton;
    btnCount: TButton;
    btnDelete: TButton;
    lblValue: TLabel;
    lblIndex: TLabel;
    edtIndex: TEdit;
    btnGetLine: TButton;
    btnInsert: TButton;
    btnLoad: TButton;
    btnSave: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    btnSetLine: TButton;
    btnUnselect: TButton;
    btnHasSelection: TButton;
    btnClearSelection: TButton;
    btnCut: TButton;
    btnCopy: TButton;
    btnPaste: TButton;
    cbxReadOnly: TCheckBox;
    cbxModified: TCheckBox;
    btnSelectAll: TButton;
    btnCaretPos: TButton;
    btnSelection: TButton;
    MainMenu1: TMainMenu;
    mitTMemo: TMenuItem;
    mitSelText: TMenuItem;
    mitInsert: TMenuItem;
    mitSetCaretPos: TMenuItem;
    procedure btnAppendClick(Sender: TObject);
    procedure btnAtEOFClick(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnClearEventsClick(Sender: TObject);
    procedure btnClearEventsMouseEnter(Sender: TObject);
    procedure btnClearEventsMouseLeave(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure btnClearClick(Sender: TObject);
    procedure btnCountClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnGetLineClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnSetLineClick(Sender: TObject);
    procedure btnUnselectClick(Sender: TObject);
    procedure btnHasSelectionClick(Sender: TObject);
    procedure btnClearSelectionClick(Sender: TObject);
    procedure btnCutClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
    procedure cbxReadOnlyClick(Sender: TObject);
    procedure cbxModifiedClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
    procedure btnCaretPosClick(Sender: TObject);
    procedure btnSelectionClick(Sender: TObject);
    procedure mitSelTextClick(Sender: TObject);
    procedure mitInsertClick(Sender: TObject);
    procedure mitSetCaretPosClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    procedure WriteEvent(const Value: string);
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses MMO1Insert, MMO1SetCaretPos;

{$R *.xfm}

procedure TForm1.btnAppendClick(Sender: TObject);
begin
  Memo1.Append(edtText.Text);
end;

procedure TForm1.btnAtEOFClick(Sender: TObject);
begin
  ShowMessage(^C'AtEOF = ' + BoolToStr(Memo1.AtEOF, True));
end;

procedure TForm1.btnClearEventsClick(Sender: TObject);
begin
  lblEvents.Caption := '[Events]';
end;

procedure TForm1.Memo1Click(Sender: TObject);
begin
  WriteEvent('C');
end;

procedure TForm1.Memo1DblClick(Sender: TObject);
begin
  WriteEvent('D');
end;

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  WriteEvent('.');
end;

procedure TForm1.btnClearEventsMouseEnter(Sender: TObject);
begin
  WriteEvent('e');
end;

procedure TForm1.btnClearEventsMouseLeave(Sender: TObject);
begin
  WriteEvent('l');
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  WriteEvent('d');
end;

procedure TForm1.Memo1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  WriteEvent('u');
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  WriteEvent('K');
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  WriteEvent('P');
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.btnCountClick(Sender: TObject);
begin
  ShowMessage('Number of lines = %d', [Memo1.Lines.Count]);
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := StrToIntDef(edtIndex.Text, 0);
  Memo1.Lines.Delete(Index);
end;

procedure TForm1.btnGetLineClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := StrToIntDef(edtIndex.Text, 0);
  edtText.Text := Memo1.Lines[Index];
end;

procedure TForm1.btnSetLineClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := StrToIntDef(edtIndex.Text, 0);
  Memo1.Lines[Index] := edtText.Text;
end;

procedure TForm1.btnInsertClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := StrToIntDef(edtIndex.Text, 0);
  Memo1.Lines.Insert(Index, edtText.Text);
end;

procedure TForm1.btnLoadClick(Sender: TObject);
var
  StringStream: TStringStream;
  FileStream: TFileStream;
begin
  // TODO: fill in event handler
  if OpenDialog1.Execute then
  begin
    StringStream := TStringStream.Create('');
    try
      FileStream := TFileStream.Create(OpenDialog1.FileName,
          fmOpenRead, fmShareDenyWrite);
      try
        // copy the whole FileStream
        StringStream.CopyFrom(FileStream, 0);
        Memo1.Text := StringStream.DataString;
      finally
        FileStream.Free;
      end;
    finally
      StringStream.Free;
    end;
  end;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
var
  StringStream: TStringStream;
  FileStream: TFileStream;
begin
  if SaveDialog1.Execute then
  begin
    StringStream := TStringStream.Create(Memo1.Text);
    try
      FileStream := TFileStream.Create(SaveDialog1.FileName,
          fmCreate, fmShareDenyWrite);
      try
        // copy the whole StringStream
        FileStream.CopyFrom(StringStream, 0);
      finally
        FileStream.Free;
      end;
    finally
      StringStream.Free;
    end;
  end;
end;

procedure TForm1.WriteEvent(const Value: string);
begin
  lblEvents.Caption := lblEvents.Caption + Value;
  while (Length(lblEvents.Caption) * 8) > lblEvents.Width do
    lblEvents.Caption := Copy(lblEvents.Caption, 2, 255);
end;

procedure TForm1.btnUnselectClick(Sender: TObject);
begin
  Memo1.UnSelect;
end;

procedure TForm1.btnHasSelectionClick(Sender: TObject);
begin
  ShowMessage(^C'HasSelection = ' + BoolToStr(Memo1.HasSelection, True));
end;

procedure TForm1.btnClearSelectionClick(Sender: TObject);
begin
  Memo1.ClearSelection;
end;

procedure TForm1.btnCutClick(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TForm1.btnCopyClick(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TForm1.btnPasteClick(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TForm1.cbxReadOnlyClick(Sender: TObject);
begin
  Memo1.ReadOnly := cbxReadOnly.Checked;
end;

procedure TForm1.cbxModifiedClick(Sender: TObject);
begin
  Memo1.Modified := cbxModified.Checked;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  cbxModified.Checked := Memo1.Modified;
  WriteEvent('M');
end;

procedure TForm1.btnSelectAllClick(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TForm1.btnCaretPosClick(Sender: TObject);
begin
  ShowMessage('CaretPos: Line = %d Col = %d', [Memo1.CaretPos.Line, Memo1.CaretPos.Col]);
end;

procedure TForm1.btnSelectionClick(Sender: TObject);
begin
  ShowMessage('CaretPos:'^M'  Line1 = %d Col1 = %d'^M'  Line2 = %d Col2 = %d',
      [Memo1.Selection.Line1, Memo1.Selection.Col1,
      Memo1.Selection.Line2, Memo1.Selection.Col2]);
end;

procedure TForm1.mitSelTextClick(Sender: TObject);
begin
  ShowMessage(^C'SelText = ''%s''', [Memo1.SelText]);
end;

procedure TForm1.mitInsertClick(Sender: TObject);
begin
  if frmInsert.ShowModal = mrOk then
    with frmInsert do
      Memo1.Insert(InsertText, Column, Row, Mark);
end;

procedure TForm1.mitSetCaretPosClick(Sender: TObject);
var
  CaretPos: TCaretPos;
begin
  if frmSetCaretPos.ShowModal = mrOk then
  begin
    CaretPos.Line := frmSetCaretPos.Row;
    CaretPos.Col := frmSetCaretPos.Column;
    Memo1.CaretPos := CaretPos;
  end;
end;

end.
