
{*******************************************************}
{                                                       }
{ DWPL Demo projects for NetCLX                         }
{ HttpMain.pas                                          }
{                                                       }
{ for Delphi 6, 7                                       }
{ Version 2.6.0                                         }
{ Copyright (c) 2003 by The DWP-Group                   }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - ICS - Internet Component Suite                    }
{     Copyright (C) 1997-2002 by Franois PIETTE        }
{     e-mail: francois.piette@overbyte.be               }
{             francois.piette@swing.be                  }
{             francois.piette@rtfm.be                   }
{             francois.piette@pophost.eunet.be          }
{     www: http://overbyte.delphicenter.com             }
{     Realeased under the terms of the Legal Issues     }
{     from the ICS - Internet Component Suite           }
{     license agreement.                                }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois PIETTE
Creation:     November 23, 1997
Version:      1.05
Description:  Sample program to demonstrate some of the THttpClient features.
EMail:        http://www.overbyte.be        http://www.rtfm.be/fpiette
              francois.piette@overbyte.be   francois.piette@rtfm.be
                                            francois.piette@pophost.eunet.be
Support:      Use the mailing list twsocket@elists.org
              Follow "support" link at http://www.overbyte.be for subscription.
Legal issues: Copyright (C) 1997-2002 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. You must register this software by sending a picture postcard
                 to the author. Use a nice stamp and mention your name, street
                 address, EMail address and any comment you like to say.

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

{
  $Header: /cvsroot/dwpl/dwpl/demos/clx/sockets/httpclient/HttpMain.pas,v 1.2 2003/10/07 18:53:00 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: HttpMain.pas,v $
  Revision 1.2  2003/10/07 18:53:00  iwache
  Demo now uses Application.Idle for periodical network update.
  Error message display spitted into two lines.

  Revision 1.1  2003/09/22 18:55:19  iwache
  Sample program to demonstrate use of the
  TTHttpClients unit. This is a adapted version
  from original code by Franois PIETTE.

  ----------------------------------------------------------------------------
}

unit HttpMain;

interface

{$IFDEF VCL}
uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles, HttpClients, Sockets, SocketUtils;
{$ELSE}
uses
  SysUtils, Classes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QExtCtrls, IniFiles, HttpClients, Sockets, SocketUtils;
{$ENDIF}

type
  THttpTestForm = class(TForm)
    DisplayList: TListBox;
    DocumentList: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    GetButton: TButton;
    URLEdit: TEdit;
    ProxyPortEdit: TEdit;
    PostButton: TButton;
    Check64Button: TButton;
    DataEdit: TEdit;
    DateTimeEdit: TEdit;
    HeadButton: TButton;
    AbortButton: TButton;
    ParseButton: TButton;
    ProxyHostEdit: TEdit;
    procedure GetButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure PostButtonClick(Sender: TObject);
    procedure Check64ButtonClick(Sender: TObject);
    procedure HeadButtonClick(Sender: TObject);
    procedure AbortButtonClick(Sender: TObject);
    procedure ParseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DisplayListDblClick(Sender: TObject);
    procedure DocumentListDblClick(Sender: TObject);
  private
    HttpCli1: THttpClient;
    Initialized: Boolean;
    DocFileName: string;
    procedure HttpCli1Command(Sender: TObject; var s: string);
    procedure HttpCli1DocBegin(Sender: TObject);
    procedure HttpCli1DocEnd(Sender: TObject);
    procedure HttpCli1RequestDone(Sender: TObject; RqType: THttpRequest;
      Error: Word);
    procedure HttpCli1HeaderData(Sender: TObject);
    procedure HttpCli1Cookie(Sender: TObject; const Data: string;
      var Accept: Boolean);
    procedure HttpCli1LocationChange(Sender: TObject);
    procedure SetButtonState(State: Boolean);
    procedure Display(const Msg: string);
    procedure ApplicationIdle(Sender: TObject; var Done: Boolean);
  end;

var
  HttpTestForm: THttpTestForm;

implementation

{$R *.DFM}

const
  IniFileName = '.\httptest.ini';
  SectionData = 'Data';
  KeyUrl = 'URL';
  KeyProxyHost = 'ProxyHost';
  KeyProxyPort = 'ProxyPort';
  KeyData = 'Data';
  KeyDateTime = 'DateTime';

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if not Initialized then
  begin
    Initialized := TRUE;
    IniFile := TIniFile.Create(IniFileName);
    URLEdit.Text := IniFile.ReadString(SectionData, KeyURL, '');
    ProxyHostEdit.Text := IniFile.ReadString(SectionData, KeyProxyHost, '');
    ProxyPortEdit.Text := IniFile.ReadString(SectionData, KeyProxyPort, '80');
    DataEdit.Text := IniFile.ReadString(SectionData, KeyData, '');
    DateTimeEdit.Text := IniFile.ReadString(SectionData, KeyDateTime, '');
    IniFile.Free;
    DisplayList.Clear;
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(IniFileName);
  IniFile.WriteString(SectionData, KeyURL, URLEdit.Text);
  IniFile.WriteString(SectionData, KeyProxyHost, ProxyHostEdit.Text);
  IniFile.WriteString(SectionData, KeyProxyPort, ProxyPortEdit.Text);
  IniFile.WriteString(SectionData, KeyData, DataEdit.Text);
  IniFile.WriteString(SectionData, KeyDateTime, DateTimeEdit.Text);
  IniFile.UpdateFile;
  IniFile.Free;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Display a message in display memo box, making sure we don't overflow it.  }

procedure THttpTestForm.Display(const Msg: string);
begin
  DisplayList.Items.BeginUpdate;
  try
    if DisplayList.Items.Count > 200 then
    begin
      { We preserve only 200 lines }
      while DisplayList.Items.Count > 200 do
        DisplayList.Items.Delete(0);
    end;
    DisplayList.Items.Add(Msg);
  finally
    DisplayList.Items.EndUpdate;
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HeadButtonClick(Sender: TObject);
var
  I: Integer;
begin
  DisplayList.Clear;
  DocumentList.Clear;
  SetButtonState(FALSE);
  try
    HttpCli1.URL := URLEdit.Text;
    HttpCli1.Proxy := ProxyHostEdit.Text;
    HttpCli1.ProxyPort := ProxyPortEdit.Text;
    HttpCli1.RcvdStream := nil;
    if DateTimeEdit.Text <> '' then
      HttpCli1.ModifiedSince := StrToDateTime(DateTimeEdit.Text)
    else
      HttpCli1.ModifiedSince := 0;

    if HttpCli1.Proxy <> '' then
      Display('Using proxy ''' + HttpCli1.Proxy + ':' +
        HttpCli1.ProxyPort + '''')
    else
      Display('Not using proxy');

    try
      HttpCli1.Head;
    except
      Display('HEAD Failed !');
      Display('StatusCode   = ' + IntToStr(HttpCli1.StatusCode));
      Display('ReasonPhrase = ' + HttpCli1.ReasonPhrase);
      Exit;
    end;

    Display('StatusCode = ' + IntToStr(HttpCli1.StatusCode));

    for I := 0 to HttpCli1.RcvdHeader.Count - 1 do
      Display('hdr>' + HttpCli1.RcvdHeader.Strings[I]);
  finally
    SetButtonState(TRUE);
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.GetButtonClick(Sender: TObject);
var
  I: Integer;
  DataIn: TStream;
begin
  DisplayList.Clear;
  DocumentList.Clear;
  SetButtonState(FALSE);
  try
    HttpCli1.URL := URLEdit.Text;
    HttpCli1.Proxy := ProxyHostEdit.Text;
    HttpCli1.ProxyPort := ProxyPortEdit.Text;
    HttpCli1.AcceptLanguage := 'en, fr';
    HttpCli1.RcvdStream := nil;
    if DateTimeEdit.Text <> '' then
      HttpCli1.ModifiedSince := StrToDateTime(DateTimeEdit.Text)
    else
      HttpCli1.ModifiedSince := 0;

    if HttpCli1.Proxy <> '' then
      Display('Using proxy ''' + HttpCli1.Proxy + ':' +
        HttpCli1.ProxyPort + '''')
    else
      Display('Not using proxy');

    try
      HttpCli1.Get;
    except
      Display('GET Failed !');
      Display('StatusCode   = ' + IntToStr(HttpCli1.StatusCode));
      Display('ReasonPhrase = ' + HttpCli1.ReasonPhrase);
      HttpCli1DocEnd(nil); { This will close the file }
      Exit;
    end;

    Display('StatusCode = ' + IntToStr(HttpCli1.StatusCode));

    for I := 0 to HttpCli1.RcvdHeader.Count - 1 do
      Display('hdr>' + HttpCli1.RcvdHeader.Strings[I]);

    if Length(DocFileName) = 0 then
    begin
      DocumentList.Items.Add('*** NO DOCUMENT FILE NAME ***');
    end
    else
    begin
      DataIn := TFileStream.Create(DocFileName, fmOpenRead);
      try
        if Copy(HttpCli1.ContentType, 1, 5) = 'text/' then
          DocumentList.Items.LoadFromStream(DataIn)
        else
        begin
          DocumentList.Items.Add('Content type is ' +
            HttpCli1.ContentType);
          DocumentList.Items.Add('Document stored in ''' +
            DocFileName +
            ''' Size=' + IntToStr(DataIn.Size));
        end;
      finally
        DataIn.Free;
      end;
    end;
  finally
    SetButtonState(TRUE);
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.PostButtonClick(Sender: TObject);
var
  DataOut: TMemoryStream;
  DataIn: TFileStream;
  Buf: string;
  I: Integer;
begin
  DisplayList.Clear;
  DocumentList.Clear;
  SetButtonState(FALSE);
  try
    DataOut := TMemoryStream.Create;
    Buf := DataEdit.Text;
    if Length(Buf) > 0 then { Check if some data to post }
      DataOut.Write(Buf[1], Length(Buf));
    DataOut.Seek(0, soFromBeginning);

    HttpCli1.SendStream := DataOut;
    HttpCli1.Proxy := ProxyHostEdit.Text;
    HttpCli1.ProxyPort := ProxyPortEdit.Text;
    HttpCli1.RcvdStream := nil;
    HttpCli1.URL := URLEdit.Text;

    if HttpCli1.Proxy <> '' then
      Display('Using proxy ''' + HttpCli1.Proxy + ':' +
        HttpCli1.ProxyPort + '''')
    else
      Display('Not using proxy');

    try
      HttpCli1.Post;
    except
      DataOut.Free;
      Display('POST Failed !');
      Display('StatusCode   = ' + IntToStr(HttpCli1.StatusCode));
      Display('ReasonPhrase = ' + HttpCli1.ReasonPhrase);
      Exit;
    end;
    DataOut.Free;

    Display('StatusCode = ' + IntToStr(HttpCli1.StatusCode));

    for I := 0 to HttpCli1.RcvdHeader.Count - 1 do
      Display('hdr>' + HttpCli1.RcvdHeader.Strings[I]);

    DataIn := TFileStream.Create(HttpCli1.DocName, fmOpenRead);
    try
      DocumentList.Items.LoadFromStream(DataIn);
    finally
      DataIn.Free;
    end;
  finally
    SetButtonState(TRUE);
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1Command(Sender: TObject; var s: string);
begin
  Display('cmd> ' + s);
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1DocBegin(Sender: TObject);
begin
  Display(HttpCli1.ContentType + ' => ' + HttpCli1.DocName);
  Display('Document = ' + HttpCli1.DocName);

  DocFileName := HttpCli1.DocName;

  if HttpCli1.ContentType = 'image/gif' then
    ReplaceExt(DocFileName, 'gif')
  else if HttpCli1.ContentType = 'image/jpeg' then
    ReplaceExt(DocFileName, 'jpg')
  else if HttpCli1.ContentType = 'image/bmp' then
    ReplaceExt(DocFileName, 'bmp');

  if DocFileName = '' then
    DocFileName := 'HttpTst.htm';
  try
    HttpCli1.RcvdStream := TFileStream.Create(DocFileName, fmCreate);
  except
    on E: Exception do
    begin
      Display('Error opening file: ' + E.Message);
      DocFileName := 'HttpTst.htm';
      Display('Using default file name: ' + DocFileName);
      HttpCli1.RcvdStream := TFileStream.Create(DocFileName, fmCreate);
    end;
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1DocEnd(Sender: TObject);
begin
  if HttpCli1.RcvdStream <> nil then
  begin
    HttpCli1.RcvdStream.Free;
    HttpCli1.RcvdStream := nil;
  end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.Check64ButtonClick(Sender: TObject);
const
  Inp: string = 'Aladdin:open sesame';
  Res: string = 'QWxhZGRpbjpvcGVuIHNlc2FtZQ==';
begin
  if EncodeLine(encBase64, @Inp[1], Length(Inp)) <> Res then
    Display('Base64 encoding do not work !')
  else
    Display('Base64 encoding works OK !');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.SetButtonState(State: Boolean);
begin
  GetButton.Enabled := State;
  PostButton.Enabled := State;
  HeadButton.Enabled := State;
  AbortButton.Enabled := not State;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1RequestDone(Sender: TObject;
  RqType: THttpRequest; Error: Word);
begin
  SetButtonState(TRUE);
  if Error <> 0 then
  begin
    Display('ReqDn Error = ' + IntToStr(Error));
    Display('(' + SocketErrorDesc(Error) + ')');
  end
  else
    Display('RequestDone, no error');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.AbortButtonClick(Sender: TObject);
begin
  HttpCli1.Abort;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.ParseButtonClick(Sender: TObject);
var
  Proto, User, Pass, Host, Port, Path: string;
begin
  ParseURL(URLEdit.Text, Proto, User, Pass, Host, Port, Path);
  Display('URL   = ''' + URLEdit.Text + '''');
  Display('Proto = ''' + Proto + '''');
  Display('Host  = ''' + Host + '''');
  Display('Path  = ''' + Path + '''');
  Display('Port  = ''' + Port + '''');
  Display('User  = ''' + User + '''');
  Display('Pass  = ''' + Pass + '''');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1HeaderData(Sender: TObject);
begin
  // Display('Header: "' + HttpCli1.LastResponse + '"');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1Cookie(Sender: TObject; const Data: string;
  var Accept: Boolean);
begin
  Display('Cookie: "' + Data + '"');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.HttpCli1LocationChange(Sender: TObject);
begin
  Display('Location changed to "' + HttpCli1.Location + '"');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

procedure THttpTestForm.FormCreate(Sender: TObject);
begin
  HttpCli1 := THttpClient.Create(Self);
  with HttpCli1 do
  begin
    OnHeaderData := HttpCli1HeaderData;
    OnCommand := HttpCli1Command;
    OnDocBegin := HttpCli1DocBegin;
    OnDocEnd := HttpCli1DocEnd;
    OnRequestDone := HttpCli1RequestDone;
    OnLocationChange := HttpCli1LocationChange;
    OnCookie := HttpCli1Cookie;
  end;

  Application.OnIdle := ApplicationIdle;
end;

procedure THttpTestForm.DisplayListDblClick(Sender: TObject);
begin
  DisplayList.Clear;
end;

procedure THttpTestForm.DocumentListDblClick(Sender: TObject);
begin
  DocumentList.Clear;
end;

procedure THttpTestForm.ApplicationIdle(Sender: TObject; var Done: Boolean);
begin
  Sockets.UpdateNetwork;
end;

end.

