unit MyThreads;

interface

uses
  Classes, Threads;

type
  TThreadOne = class(TThread)
  private
    FName: string;
    procedure LogMessage;
  protected
    procedure Execute; override;
  public
    property Name: string read FName write FName;
  end;

  TThreadTwo = class(TThread)
  private
    procedure LogMessage;
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

uses
  Unit1;

{ ThreadOne }

procedure TThreadOne.Execute;
var
  P: Pointer;
  I: Integer;
begin
  for I := 1 to 20 do
  begin
    if Terminated then Break;
    GetMem(P, 30000);
    Synchronize(LogMessage);
    Sleep(500);
    FreeMem(P);
  end;
  ReturnValue := 42;
end;

procedure TThreadOne.LogMessage;
begin
  Form1.LogMessage(Name);
end;

{ ThreadTwo }

procedure TThreadTwo.Execute;
var
  P: Pointer;
begin
  repeat
    GetMem(P, 30000);
    Synchronize(LogMessage);
    Sleep(1000);
    FillChar(P^, 30000, 0);
    FreeMem(P);
  until Terminated;
end;

procedure TThreadTwo.LogMessage;
begin
  Form1.LogMessage('Thread 2');
end;

end.
