program THR1;

{$APPTYPE CONSOLE}

uses
  Crt,
  Threads,
  MyThreads in 'MyThreads.pas';

type
  TList = class
    procedure Terminate(Sender: TObject);
  end;

procedure TList.Terminate(Sender: TObject);
begin
  Writeln(Sender.ClassName + ' terminated - Press Enter...');
  Readln; // <-- this is only for test, don't use Readln with Threads
end;

var
  List: TList;
  ThreadOne: TThreadOne;
  ThreadTwo: TThreadTwo;
  ThreadOneMore: TThreadOne;
begin
  // for test of OnTerminate
  List := TList.Create;

  // create suspended
  ThreadOne := TThreadOne.Create(True);
  ThreadOne.Name := 'ThreadOne';
  ThreadOne.OnTerminate := List.Terminate;

  // create not suspended
  ThreadTwo := TThreadTwo.Create(False);
  ThreadTwo.OnTerminate := List.Terminate;

  // test free on terminate
  ThreadOneMore := TThreadOne.Create(False);
  ThreadOneMore.FreeOnTerminate := True;
  ThreadOneMore.Name := 'ThreadOneMore';

  // test WaitFor
  Writeln(ThreadOneMore.WaitFor);
  Writeln('Press Enter...');
  Readln;

  repeat
    WriteLn('Main Thread');

    // test sleep(0)
    Sleep(0);

    if KeyPressed then
      case ReadKey of
        '1':
          begin
            // test Suspend and Resume
            if ThreadOne.Suspended then
              ThreadOne.Resume
            else
              ThreadOne.Suspend;
          end;
        '2':
          begin
            if ThreadTwo.Suspended then
              ThreadTwo.Resume
            else
              ThreadTwo.Suspend;
          end;
        // test Terminate with ThreadTwo
        '3': ThreadTwo.Terminate;
        #27: Break;
      end;
  until False;

  ThreadOne.Free;
  ThreadTwo.Free;
  List.Free;
end.

