
{*******************************************************}
{                                                       }
{ DWPL Delphi WDosX Core Library                        }
{ V24.dpr                                               }
{                                                       }
{ for Delphi  5-7                                       }
{ Version 2.6.0                                         }
{ Copyright (c) 2001-2003 by Thomas@Bornhaupt           }
{ e-mail: Thomas@Bornhaupt.de                           }
{ www: http://www.Bornhaupt.de                          }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software based on:                               }
{                                                       }
{   - DWPL Delphi WDosX pROJECT Library                 }
{     Copyright (c) 2001-2003 by Team-DWP               }
{     e-mail: immo.wache@dwp42.org                      }
{     www: http://www.dwp42.org                         }
{                                                       }
{*******************************************************}

{
  $Header: /cvsroot/dwpl/dwpl/demos/rtl/wdosx/serialports/V24.dpr,v 1.1 2003/09/22 18:50:45 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: V24.dpr,v $
  Revision 1.1  2003/09/22 18:50:45  iwache
  The demo project for the serial port access unit
  by Thomas Bornhaupt.

  ----------------------------------------------------------------------------
}

program V24;

{$APPTYPE CONSOLE}

{$R *.RES}

uses
   SysUtils,
   Crt,
   WDosComCtrl;
var
   CC1: TwdxComCtrl;
   CC2: TwdxComCtrl;
   b: Byte;
   c: char;
   s1, s2: string;
begin
   writeln('V24 serial test for Delphi 5 up on WDOSX');
   writeln;
   writeln('COM1: ',IntToHex(TwdxComCtrl.ComDeviceBaseAddr(Com1), 4));
   writeln('COM2: ',IntToHex(TwdxComCtrl.ComDeviceBaseAddr(Com2), 4));
   writeln;
   writeln('Connect Com1 and Com2 with null-modem-cable');
   writeln;
   writeln('h: Com1 -> Com2: Hello World');
   writeln('H: Com2 -> Com1: Hello World');
   writeln('s: Com1 -> Com2: Nice is Delphi on DOS');
   writeln('S: Com2 -> Com1: Nice is Delphi on DOS');
   writeln('ESC: Exit');
   writeln;
   
   CC1 := TwdxComCtrl.Create(nil);                     
   CC2 := TwdxComCtrl.Create(nil);
   try
      CC2.ComDevice := com2;

      CC1.Open;
      try
         CC2.Open;
         try
            s1 := '';
            s2 := '';
            writeln('ComDevice1: ', CC1.ComDeviceStr);
            writeln('ComDevice2: ', CC2.ComDeviceStr);
            repeat
               repeat
                  while CC1.DataAvail do begin
                     b := CC1.GetByte;
                     if b <> 10 then begin
                        s1 := s1 + Char(b);
                     end
                     else begin
                        writeln('Com2->Com1: ',s1);
                        s1:='';
                     end;      
                  end;
                  while CC2.DataAvail do begin
                     b := CC2.GetByte;
                     if b <> 10 then begin
                        s2 := s2 + Char(b);
                     end
                     else begin
                        writeln('Com1->Com2: ',s2);
                        s2:='';
                     end;
                  end;
               until keypressed; 
               c := Readkey;
               case c of
                  'h': cc1.Send('Hello World'#10);
                  'H': cc2.Send('Hello World'#10);
                  's': cc1.Send('Nice is Delphi on DOS'#10);
                  'S': cc2.Send('Nice is Delphi on DOS'#10);
               end;
            until c = #27;
         finally
            CC2.Close;
         end;
      finally
         CC1.Close;
      end;
   finally
      CC2.free;
      CC1.free;
   end;
   writeln;
   writeln('--- ready ---');
end.
