unit SocketInfos;

interface

uses
  SysUtils, Classes, WDosSock, WDosIP, WDosNetwork;

procedure DisplaySocketInfos;

implementation

procedure DisplaySocketInfos;
var
  RE: TRouteEntry;
  AE: TAddressEntry;
  I: Integer;
  EthernetAddress: TEthernetAddress;
begin
  // Display network information
  WDosSock.NetworkAdapter.GetAddress(EthernetAddress);
  IP_GetInfo(0, AE);
  Writeln('IP Information');
  Writeln('--------------');
  Writeln('Adapter   : ', WDosSock.NetworkAdapter.AdapterName, ' (',
      Ethernet_AddrToString(EthernetAddress), ')');
  Writeln('IP Address: ', IP_AddrToString(AE.IPAddress));
  Writeln('Net Mask  : ', IP_AddrToString(AE.NetMask));
  Writeln('DHCP Used : ', AE.DHCPInUse);
  Writeln;
  Writeln('Routing Table');
  Writeln('-------------');
  Writeln('Destination     Mask            Local IP        Gateway          Cost');
  Writeln('--------------- --------------- --------------- --------------- -----');
  I := 0;
  while IP_GetRoute(I, RE) do
  begin
    Writeln(Format('%-15s %-15s %-15s %-15s %5d', [
        IP_AddrToString(RE.Destination), IP_AddrToString(RE.Mask),
        IP_AddrToString(RE.LocalIP), IP_AddrToString(RE.Gateway), RE.Cost]));
    Inc(I);
  end;
  Writeln;
end;

end.
