unit BkGndApp;

interface

uses
  ViTypes, ViUtils, ViClasses, ViViews, ViApp, ViScreens,
  ViMenus, ViDialogs, ViStdDlg, ViMsgBox;

const
  cmMsgDialog = 105;

type
  TBkGndApplication = class(TViApplication)
    procedure HandleEvent(var Event: TEvent); override;
  public
    constructor Create;
    destructor Destroy; override;
    procedure InitDesktop; override;
    procedure InitMenuBar; override;
    procedure InitStatusLine; override;
    procedure Run; override;
  private
    procedure MsgDialog;
  end;

var
  MyApp: TBkGndApplication;

implementation

uses
  ViMouses,
  ViEventsClass,
  DOSBkGnd;

procedure TBkGndApplication.InitMenuBar;
begin
  ViMenuBar := nil;
end;

procedure TBkGndApplication.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y + 1; { below screen bottom }
  ViStatusLine := TViStatusLine.Create(R, NewStatusDef(0, $EFFF,
    NewStatusKey('', kbEsc, cmQuit,
    NewStatusKey('', kbAltX, cmQuit,
    NewStatusKey('', kbAltF4, cmQuit,
    nil))),
    nil));
end;

procedure TBkGndApplication.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmMsgDialog: MsgDialog;
      else
        Exit;
      end;
  end;

  ClearEvent(Event);
end;

procedure TBkGndApplication.InitDesktop;
var
  R: TRect;
begin
  GetExtent(R);
  ViDesktop := TDOSDesktop.Create(R); { construct custom desktop }
end;

constructor TBkGndApplication.Create;
var
  Event: TEVent;
begin
  SaveScreen;
  inherited;
  Event.What := evCommand;
  Event.Command := cmMsgDialog;
  PutEvent(Event);
end;

procedure TBkGndApplication.Run;
begin
  inherited;
end;

destructor TBkGndApplication.Destroy;
begin
  inherited;
  RestoreScreen;
end;

procedure TBkGndApplication.MsgDialog;
begin
  MessageBox(#3'Turbo Vision'#13#3, mfInformation or mfOKButton);
end;

end.

