unit DOSBkGnd;

interface

uses
  ViTypes, ViUtils, ViClasses, ViViews, ViApp, ViScreens,
  ViMenus, ViDialogs, ViStdDlg,
  ViMsgBox;

type
  TDOSBackground = class(TViBackground)
  public
    constructor Create(var Bounds: TRect; APattern: Char);
    procedure Draw; override;
  end;

  TDOSDesktop = class(TViDesktop)
  public
    constructor Create(var Bounds: TRect);
    procedure InitBackground; override;
  end;

procedure SaveScreen;
procedure RestoreScreen;

implementation

uses
  CRT,
  {must be before WinScreens/WDosScreens to use whereX/whereY
  from WinScreens/WDosScreens instead of crt! }
{$IFDEF WIN}
  WinScreens;
{$ELSE}
  WDosScreens;
{$ENDIF}

var
  xVbuf: PByteArray;
  scr: TScr;

procedure SaveScreen;
begin
  if xVbuf = nil then
    GetMem(xVbuf, ViScreen.Width * ViScreen.Height * 2);

  with scr do
  begin
    oldx := wherex;
    oldy := wherey;
    oldattr := textattr;
  end;
  GetText(1, 1, ViScreen.Width, ViScreen.Height, xVbuf, ViScreen.Width * 2);
end;

procedure RestoreScreen;
begin
  if xVbuf <> nil then
  begin
    puttext(1, 1, ViScreen.Width, ViScreen.Height, xVbuf, ViScreen.Width * 2);
    FreeMem(xVbuf);
    with scr do
    begin
      gotoxy(oldx, oldy);
      textattr := oldattr;
    end;
  end;
end;

constructor TDOSBackground.Create(var Bounds: TRect; APattern: Char);
begin
  inherited;
end;

procedure TDOSBackground.Draw;
begin
  if xVbuf = nil then
    SaveScreen;
  WriteBuf(0, 0, Size.X, Size.Y, xVbuf^);
end;

constructor TDOSDesktop.Create(var Bounds: TRect);
begin
  inherited Create(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  InitBackground; //use TDOSBackground
  if Background <> nil then Insert(Background);
end;

procedure TDOSDesktop.InitBackground;
var
  R: TRect;
begin
  GetExtent(R);
  if Assigned(Background) then
    Background.Free;
  Background := TDOSBackground.Create(R, ldDesktopBackground);
end;

end.

