
{*******************************************************}
{                                                       }
{ DWPL Delphi WDosX and Cross Platform Library          }
{ (automation)                                          }
{ ModbusConst.pas                                       }
{                                                       }
{ for Delphi 5, 6, 7                                    }
{ Version 2.6.0                                         }
{ Copyright (c) 2000-2003 by Team-DWP                   }
{ e-mail: team-dwp@dwp42.org                            }
{ www: http://www.dwp42.org                             }
{                                                       }
{ The initial developer of the code is                  }
{   Immo Wache, immo.wache@dwp42.org                    }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ Licensees holding a valid Team-DWP No-Nonsense        }
{ License for this Software may use this file in        }
{ accordance with such license, which appears in        }
{ the file license.txt that came with this software.    }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/automation/ModbusConst.pas,v 1.1 2003/11/06 20:26:49 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: ModbusConst.pas,v $
  Revision 1.1  2003/11/06 20:26:49  iwache
  Units for Modbus/TCP access to automation added.

  ----------------------------------------------------------------------------
}

unit ModbusConst;

interface

resourcestring
  // common
  sModbusTcpClientNotIdle = 'ModbusTcpClient is not in idle mode';

  // Names of modbus functions
  SUnknown = 'Unknown modbus function';
  SReadCoils = 'Read coils';
  SReadInputDiscretes = 'Read input discretes';
  SReadMultipleRegisters = 'Read multiple registers';
  SReadInputRegisters = 'Read input registers';
  SWriteCoil = 'Write coil';
  SWriteSingleRegister = 'Write single register';
  SReadExceptionStatus = 'Read exception status';
  SGetCommEventCounter = 'Get comm event counter';
  SForceMultipleCoils = 'Force multiple coils';
  SWriteMultipleRegisters = 'Write multiple registers';
  SReadWriteRegisters = 'Read/Write registers';

  // Modbus exception descriptions
  SExceptUnknown = 'Unknown exception';
  SExceptIllegalFunction = 'Illegal function';
  SExceptIllegalDataAddress = 'Illegal data address';
  SExceptIllegalDataValue = 'Illegal data value';
  SExceptIllegalResponseLength = 'Illegal response length';
  SExceptAcknowledge = 'Acknowledge';
  SExceptSlaveDeviceBusy = 'Slave device busy';
  SExceptNegativeAcknowledge = 'Negative acknowledge';
  SExceptMemoryParityError = 'Memory parity error';
  SExceptGatewayPathUnavailable = 'Gateway path unavailable';
  SExceptGatewayTargetDeviceFailed = 'Gateway target device failed to respond';

implementation

end.
