
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (clx/vi)      }
{ ViApp.pas                                             }
{                                                       }
{ for Delphi 4, 5, 6                                    }
{ Version 2.0                                           }
{ Copyright (c) 2001 by Immo Wache                      }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - Turbo Pascal Version 7.0                          }
{     Turbo Vision Unit                                 }
{     Copyright (c) 1992 Borland International          }
{     www: http://www.borland.com                       }
{   - Virtual Pascal v2.1                               }
{     Copyright (C) 1996-2000 vpascal.com               }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/clx/wq/vi/ViApp.pas,v 1.8 2003/10/28 20:16:26 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: ViApp.pas,v $
  Revision 1.8  2003/10/28 20:16:26  iwache
  For better mouse initialization ViEvents.Init and ViEvents.Done
  are now done after Create application and before Destroy application.

  Revision 1.7  2003/10/07 19:21:24  iwache
  Application.OnIdle event support added.

  Revision 1.6  2003/01/31 21:32:41  iwache
  Threads.Sleep(0) added to the main event loop. This is the multitasking
  support from the main tread of a DWPL VisualCLX application.

  Revision 1.5  2002/10/27 22:25:16  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
unit ViApp;

{$X+,I-}

interface

uses
{$IFDEF WIN}
  WinMessages,
{$ENDIF}
{$IFDEF WDOSX}
  WDosMessages,
{$ENDIF}
  Threads,
  ViTypes, ViUtils, ViClasses, ViScreens, ViViews,
  ViMenus, ViDialogs;

const

{ TApplication palette entries }

  apColor = 0;
  apBlackWhite = 1;
  apMonochrome = 2;

{ TApplication palettes }

  { Turbo Vision 1.0 Color Palettes }

  CColor =
    #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00;

  CBlackWhite =
    #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$0F +
    #$07#$0F#$07#$70#$70#$07#$70#$0F#$70#$7F#$7F#$70#$07#$70#$07#$0F +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00;

  CMonochrome =
    #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00;

  { Turbo Vision 2.0 Color Palettes }

  CAppColor =
    #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

  CAppBlackWhite =
    #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$0F +
    #$07#$0F#$07#$70#$70#$07#$70#$0F#$70#$7F#$7F#$70#$07#$70#$07#$0F +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00 +
    #$07#$0F#$0F#$07#$70#$07#$07#$0F#$0F#$70#$78#$7F#$08#$7F#$08#$70 +
    #$7F#$7F#$7F#$0F#$70#$70#$07#$70#$70#$70#$07#$7F#$70#$07#$78#$00 +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00;

  CAppMonochrome =
    #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00;

{ TBackground palette }

  CBackground = #1;

{ Standard application commands }

  cmNew = 30;
  cmOpen = 31;
  cmSave = 32;
  cmSaveAs = 33;
  cmSaveAll = 34;
  cmChangeDir = 35;
  cmDosShell = 36;
  cmCloseAll = 37;

{ Standard application help contexts }

{ Note: range $FF00 - $FFFF of help contexts are reserved by Borland }

  hcNew = $FF01;
  hcOpen = $FF02;
  hcSave = $FF03;
  hcSaveAs = $FF04;
  hcSaveAll = $FF05;
  hcChangeDir = $FF06;
  hcDosShell = $FF07;
  hcExit = $FF08;

  hcUndo = $FF10;
  hcCut = $FF11;
  hcCopy = $FF12;
  hcPaste = $FF13;
  hcClear = $FF14;

  hcTile = $FF20;
  hcCascade = $FF21;
  hcCloseAll = $FF22;
  hcResize = $FF23;
  hcZoom = $FF24;
  hcNext = $FF25;
  hcPrev = $FF26;
  hcClose = $FF27;

type

{ TBackground }

  TViBackground = class(TViView)
  public
    Pattern: Char;
    constructor Create(var Bounds: TRect; APattern: Char);
    procedure Draw; override;
  end;

{ TDesktop }

  TViDesktop = class(TViGroup)
  public
    Background: TViBackground;
    TileColumnsFirst: Boolean;
    constructor Create(var Bounds: TRect);
    procedure Cascade(var R: TRect);
    procedure HandleEvent(var Event: TEvent); override;
    procedure InitBackground; virtual;
    procedure Tile(var R: TRect);
    procedure TileError; virtual;
  end;

{ TProgram }

  { Palette layout }
  {     1 = TBackground }
  {  2- 7 = TMenuView and TStatusLine }
  {  8-15 = TWindow(Blue) }
  { 16-23 = TWindow(Cyan) }
  { 24-31 = TWindow(Gray) }
  { 32-63 = TDialog }

  TViProgram = class(TViGroup)
  protected
    FPalettes: array[wpBlueWindow..wpGrayWindow] of string;
    function GetPalette: TPalette; override;
    procedure SetPalette(Value: TPalette); override;
  public
    constructor Create;
    destructor Destroy; override;
    function CanMoveFocus: Boolean;
    function ExecuteDialog(P: TViDialog; Data: Pointer): Word;
    procedure GetEvent(var Event: TEvent); override;
    procedure HandleEvent(var Event: TEvent); override;
    procedure Idle; virtual;
    procedure InitDesktop; virtual;
    procedure InitMenuBar; virtual;
    procedure InitScreen; virtual;
    procedure InitStatusLine; virtual;
    function InsertWindow(P: TViWindow): TViWindow;
    procedure PutEvent(var Event: TEvent); override;
    procedure Run; virtual;
    procedure SetScreenMode(Mode: Word);
  end;

{ TApplication }

  TViApplication = class(TViProgram)
  private
    FOnIdle: TChangedEvent;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Cascade;
    procedure DosShell;
    procedure GetTileRect(var R: TRect); virtual;
    procedure HandleEvent(var Event: TEvent); override;
    procedure Tile;
    procedure WriteShellMsg; virtual;
    procedure Idle; override;
    property OnIdle: TChangedEvent read FOnIdle write FOnIdle;
  end;

{ Standard menus and status lines }


function StdStatusKeys(Next: PStatusItem): PStatusItem;

function StdFileMenuItems(Next: PMenuItem): PMenuItem;
function StdEditMenuItems(Next: PMenuItem): PMenuItem;
function StdWindowMenuItems(Next: PMenuItem): PMenuItem;


{ App registration procedure }

var

{ Public variables }

  ViApplication: TViProgram = nil;
  ViDesktop: TViDesktop = nil;
  ViStatusLine: TViStatusLine = nil;
  ViMenuBar: TViMenuView = nil;
  AppPalette: Integer = apColor;

implementation

uses
  ViMouses, ViEventsClass;

var

{ Private variables }

  Pending: TEvent = (What: evNothing);

{ TBackground }

constructor TViBackground.Create(var Bounds: TRect; APattern: Char);
begin
  inherited Create(Bounds);
  Palette := CBackground;
  GrowMode := gfGrowHiX + gfGrowHiY;
  Pattern := APattern;
end;

procedure TViBackground.Draw;
var
  B: TDrawBuffer;
begin
  MoveChar(B, Pattern, GetColor($01), Size.X);
  WriteLine(0, 0, Size.X, Size.Y, B);
end;

{ TDesktop object }

constructor TViDesktop.Create(var Bounds: TRect);
begin
  inherited Create(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  InitBackground;
  if Background <> nil then Insert(Background);
end;

function Tileable(P: TViView): Boolean;
begin
  Tileable := (P.Options and ofTileable <> 0) and
    (P.State and sfVisible <> 0);
end;

procedure TViDesktop.Cascade(var R: TRect);
var
  CascadeNum: Integer;
  LastView: TViView;
  Min, Max: TPoint;

  procedure DoCount(P: TViView);
  begin
    if Tileable(P) then
    begin
      Inc(CascadeNum);
      LastView := P;
    end;
  end;

  procedure ForEachDoCount;
  var
    Curr: TViView;
  begin
    Curr := Last;
    if not Assigned(Curr) then Exit;
    repeat
      Curr := Curr.Next;
      DoCount(Curr);
    until Curr = Last;
  end;

  procedure DoCascade(P: TViView);
  var
    NR: TRect;
  begin
    if Tileable(P) and (CascadeNum >= 0) then
    begin
      RectCopy(NR, R);
      Inc(NR.A.X, CascadeNum);
      Inc(NR.A.Y, CascadeNum);
      P.Locate(NR);
      Dec(CascadeNum);
    end;
  end;

  procedure ForEachDoCascade;
  var
    Curr: TViView;
  begin
    Curr := Last;
    if not Assigned(Curr) then Exit;
    repeat
      Curr := Curr.Next;
      DoCascade(Curr);
    until Curr = Last;
  end;

begin
  CascadeNum := 0;
  ForEachDoCount;
  if CascadeNum > 0 then
  begin
    LastView.SizeLimits(Min, Max);
    if (Min.X > R.B.X - R.A.X - CascadeNum) or
      (Min.Y > R.B.Y - R.A.Y - CascadeNum) then
      TileError
    else
    begin
      Dec(CascadeNum);
      Lock;
      ForEachDoCascade;
      Unlock;
    end;
  end;
end;

procedure TViDesktop.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmNext: FocusNext(False);
      cmPrev:
        if Valid(cmReleasedFocus) then
          Current.PutInFrontOf(Background);
    else
      Exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TViDesktop.InitBackground;
var
  R: TRect;
begin
  GetExtent(R);
  if Assigned(Background) then
    Background.Free;
  Background := TViBackground.Create(R, ldDesktopBackground);
end;

procedure TViDesktop.Tile(var R: TRect);
var
  NumCols, NumRows, NumTileable, LeftOver, TileNum: Integer;

  procedure ForEachDoCountTileable;
  var
    Curr: TViView;
  begin
    Curr := Last;
    if not Assigned(Curr) then Exit;
    repeat
      Curr := Curr.Next;
      if Tileable(Curr) then Inc(NumTileable);
    until Curr = Last;
  end;

  function DividerLoc(Lo, Hi, Num, Pos: Integer): Integer;
  begin
    DividerLoc := ((Hi - Lo) * Pos) div Num + Lo;
  end;

  procedure CalcTileRect(Pos: Integer; var NR: TRect);
  var
    X, Y, D: Integer;
  begin
    D := (NumCols - LeftOver) * NumRows;
    if Pos < D then
    begin
      X := Pos div NumRows;
      Y := Pos mod NumRows;
    end
    else
    begin
      X := (Pos - D) div (NumRows + 1) + (NumCols - LeftOver);
      Y := (Pos - D) mod (NumRows + 1);
    end;
    NR.A.X := DividerLoc(R.A.X, R.B.X, NumCols, X);
    NR.B.X := DividerLoc(R.A.X, R.B.X, NumCols, X + 1);
    if Pos >= D then
    begin
      NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows + 1, Y);
      NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows + 1, Y + 1);
    end
    else
    begin
      NR.A.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y);
      NR.B.Y := DividerLoc(R.A.Y, R.B.Y, NumRows, Y + 1);
    end;
  end;

  procedure DoTile(P: TViView);
  var
    R: TRect;
  begin
    if Tileable(P) then
    begin
      CalcTileRect(TileNum, R);
      P.Locate(R);
      Dec(TileNum);
    end;
  end;

  procedure ForEachDoTile;
  var
    Curr: TViView;
  begin
    Curr := Last;
    if not Assigned(Curr) then Exit;
    repeat
      Curr := Curr.Next;
      DoTile(Curr);
    until Curr = Last;
  end;

begin
  NumTileable := 0;
  ForEachDoCountTileable;
  if NumTileable > 0 then
  begin
    MostEqualDivisors(NumTileable, NumCols, NumRows, not TileColumnsFirst);
    if ((R.B.X - R.A.X) div NumCols = 0) or
      ((R.B.Y - R.A.Y) div NumRows = 0) then
      TileError
    else
    begin
      LeftOver := NumTileable mod NumCols;
      TileNum := NumTileable - 1;
      Lock;
      ForEachDoTile;
      Unlock;
    end;
  end;
end;

procedure TViDesktop.TileError;
begin
end;

{ TProgram }

constructor TViProgram.Create;
var
  R: TRect;
begin
  InitScreen;
  RectAssign(R, 0, 0, ViScreen.Width, ViScreen.Height);
  inherited Create(R);
  FPalettes[apColor] := CAppColor;
  FPalettes[apBlackWhite] := CAppBlackWhite;
  FPalettes[apMonochrome] := CAppMonochrome;
  ViApplication := Self;
  State := sfVisible + sfSelected + sfFocused + sfModal + sfExposed;
  Options := 0;
  Buffer := Addr(ViScreen.VideoBuffer);
  InitDesktop;
  InitStatusLine;
  InitMenuBar;
  if ViDesktop <> nil then Insert(ViDesktop);
  if ViStatusLine <> nil then Insert(ViStatusLine);
  if ViMenuBar <> nil then Insert(ViMenuBar);
end;

destructor TViProgram.Destroy;
begin
  if Assigned(ViDesktop) then ViDesktop.Free;
  if Assigned(ViMenuBar) then ViMenuBar.Free;
  if Assigned(ViStatusLine) then ViStatusLine.Free;
  ViApplication := nil;
  inherited Destroy;
end;

function TViProgram.CanMoveFocus: Boolean;
begin
  CanMoveFocus := ViDesktop.Valid(cmReleasedFocus);
end;

function TViProgram.ExecuteDialog(P: TViDialog; Data: Pointer): Word;
var
  C: Word;
begin
(*
  if Data <> nil then P.SetData(Data^);
*)
  C := ViDesktop.ExecView(P);
(*
  if (C <> cmCancel) and (Data <> nil) then P.GetData(Data^);
*)
  Result := C;
end;

procedure TViProgram.GetEvent(var Event: TEvent);

  function FirstThatContainsMouse: TViView;
  begin
    Result := Last;
    if Result = nil then Exit;
    repeat
      Result := Result.Next;
      if (Result.State and sfVisible <> 0) and
          Result.MouseInView(Event.Where) then Exit;
    until Result = Last;
    Result := nil;
  end;

begin
  if Pending.What <> evNothing then
  begin
    Event := Pending;
    Pending.What := evNothing;
  end
  else
  begin
    Threads.Sleep(0);
    ViEvents.ProcessEvents;
    ViEvents.GetMouseEvent(Event);
    if Event.What = evNothing then
    begin
      ViEvents.GetKeyEvent(Event);
      if Event.What = evNothing then Idle;
    end;
  end;

  if ViStatusLine <> nil then
    if (Event.What and evKeyDown <> 0) or
        (Event.What and evMouseDown <> 0) and
        (FirstThatContainsMouse = ViStatusLine) then
      ViStatusLine.HandleEvent(Event);
end;

procedure TViProgram.HandleEvent(var Event: TEvent);
var
  C: Char;
begin
  if Event.What = evKeyDown then
  begin
    C := GetAltChar(Event.KeyCode);
    if (C >= '1') and (C <= '9') then
      if SendMessage(ViDesktop, evBroadCast, cmSelectWindowNum,
        Pointer(Byte(C) - $30)) <> nil then ClearEvent(Event);
  end;
  inherited HandleEvent(Event);
  if Event.What = evCommand then
    if Event.Command = cmQuit then
    begin
      EndModal(cmQuit);
      ClearEvent(Event);
    end;
end;

procedure TViProgram.Idle;
begin
  if ViStatusLine <> nil then ViStatusLine.Update;
  if CommandSetChanged then
  begin
    SendMessage(Self, evBroadcast, cmCommandSetChanged, nil);
    CommandSetChanged := False;
  end;

  ProcessMessage;
end;

procedure TViProgram.InitDesktop;
var
  R: TRect;
begin
  GetExtent(R);
  Inc(R.A.Y);
  Dec(R.B.Y);
  ViDesktop := TViDesktop.Create(R);
end;

procedure TViProgram.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  ViMenuBar := TViMenuBar.Create(R, nil);
end;

procedure TViProgram.InitScreen;
begin
  if Lo(ViScreen.Mode) <> smMono then
  begin
    if ViScreen.Mode and smFont8x8 <> 0 then
      ShadowSize.X := 1
    else
      ShadowSize.X := 2;
    ShadowSize.Y := 1;
    ShowMarkers := False;
    if Lo(ViScreen.Mode) = smBW80 then
      AppPalette := apBlackWhite
    else
      AppPalette := apColor;
  end
  else
  begin
    ShadowSize.X := 0;
    ShadowSize.Y := 0;
    ShowMarkers := True;
    AppPalette := apMonochrome;
  end;
end;

procedure TViProgram.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  ViStatusLine := TViStatusLine.Create(R,
      NewStatusDef(0, $FFFF,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      StdStatusKeys(nil)), nil));
end;

function TViProgram.InsertWindow(P: TViWindow): TViWindow;
begin
  Result := nil;
  if CanMoveFocus then
  begin
    ViDesktop.Insert(P);
    Result := P;
  end
  else
    P.Free;
end;

procedure TViProgram.PutEvent(var Event: TEvent);
begin
  Pending := Event;
end;

procedure TViProgram.Run;
begin
  Execute;
end;

procedure TViProgram.SetScreenMode(Mode: Word);
var
  R: TRect;
begin
  ViMouse.Hide;
  ViScreen.Mode :=Mode;
(*
  DoneMemory;
  InitMemory;
*)
  InitScreen;
  Buffer := Addr(ViScreen.VideoBuffer);
  RectAssign(R, 0, 0, ViScreen.Width, ViScreen.Height);
  ChangeBounds(R);
  ViMouse.Show;
end;

function TViProgram.GetPalette: TPalette;
begin
  GetPalette := FPalettes[AppPalette];
end;

procedure TViProgram.SetPalette(Value: TPalette);
begin
  if FPalettes[AppPalette] <> Value then
  begin
    FPalettes[AppPalette] := Value;
  end;
end;


{ TApplication }

constructor TViApplication.Create;
begin
(*
  InitMemory;
*)
  ViScreen.InitVideo;
  ViMouse.Init;
  inherited Create;
  ViEvents.Init;
end;

destructor TViApplication.Destroy;
begin
  ViEvents.Done;
  inherited Destroy;
  ViMouse.Done;
  ViScreen.DoneVideo;
(*
  DoneMemory;
*)
end;

procedure TViApplication.Cascade;
var
  R: TRect;
begin
  GetTileRect(R);
  if Assigned(ViDesktop) then ViDesktop.Cascade(R);
end;

procedure TViApplication.DosShell;
begin
  ViEvents.Done;
  ViScreen.DoneVideo;
(*
  DoneDosMem;
*)
  WriteShellMsg;
(*
  Exec(GetEnv('COMSPEC'), '');
  InitDosMem;
*)
  ViScreen.InitVideo;
(*
  InitKeyboard;
*)
  ViEvents.Init;
  Redraw;
end;

procedure TViApplication.GetTileRect(var R: TRect);
begin
  ViDesktop.GetExtent(R);
end;

procedure TViApplication.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmTile: Tile;
          cmCascade: Cascade;
          cmDosShell: DosShell;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

procedure TViApplication.Tile;
var
  R: TRect;
begin
  GetTileRect(R);
  if Assigned(ViDesktop) then ViDesktop.Tile(R);
end;

procedure TViApplication.WriteShellMsg;
begin
  Writeln(#13#10'Type EXIT to return...'#13#10);
end;

procedure TViApplication.Idle;
begin
  inherited;
  if Assigned(FOnIdle) then OnIdle(Self);
end;


{ Standard menus and status lines }

function StdStatusKeys(Next: PStatusItem): PStatusItem;
begin
  StdStatusKeys :=
    NewStatusKey('', kbAltX, cmQuit,
    NewStatusKey('', kbF10, cmMenu,
    NewStatusKey('', kbAltF3, cmClose,
    NewStatusKey('', kbF5, cmZoom,
    NewStatusKey('', kbCtrlF5, cmResize,
    NewStatusKey('', kbF6, cmNext,
    NewStatusKey('', kbShiftF6, cmPrev,
    Next)))))));
end;

function StdFileMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdFileMenuItems :=
    NewItem('~N~ew', '', kbNoKey, cmNew, hcNew,
    NewItem('~O~pen...', 'F3', kbF3, cmOpen, hcOpen,
    NewItem('~S~ave', 'F2', kbF2, cmSave, hcSave,
    NewItem('S~a~ve as...', '', kbNoKey, cmSaveAs, hcSaveAs,
    NewItem('Save a~l~l', '', kbNoKey, cmSaveAll, hcSaveAll,
    NewLine(
    NewItem('~C~hange dir...', '', kbNoKey, cmChangeDir, hcChangeDir,
    NewItem('~D~OS shell', '', kbNoKey, cmDosShell, hcDosShell,
    NewItem('E~x~it', 'Alt+X', kbAltX, cmQuit, hcExit,
    Next)))))))));
end;

function StdEditMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdEditMenuItems :=
    NewItem('~U~ndo', '', kbAltBack, cmUndo, hcUndo,
    NewLine(
    NewItem('Cu~t~', 'Shift+Del', kbShiftDel, cmCut, hcCut,
    NewItem('~C~opy', 'Ctrl+Ins', kbCtrlIns, cmCopy, hcCopy,
    NewItem('~P~aste', 'Shift+Ins', kbShiftIns, cmPaste, hcPaste,
    NewItem('C~l~ear', 'Ctrl+Del', kbCtrlDel, cmClear, hcClear,
    Next))))));
end;

function StdWindowMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdWindowMenuItems :=
    NewItem('~T~ile', '', kbNoKey, cmTile, hcTile,
    NewItem('C~a~scade', '', kbNoKey, cmCascade, hcCascade,
    NewItem('Cl~o~se all', '', kbNoKey, cmCloseAll, hcCloseAll,
    NewLine(
    NewItem('~S~ize/Move','Ctrl+F5', kbCtrlF5, cmResize, hcResize,
    NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcZoom,
    NewItem('~N~ext', 'F6', kbF6, cmNext, hcNext,
    NewItem('~P~revious', 'Shift+F6', kbShiftF6, cmPrev, hcPrev,
    NewItem('~C~lose', 'Alt+F3', kbAltF3, cmClose, hcClose,
    Next)))))))));
end;

end.

