
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (clx/vi)      }
{ ViHistList.pas                                        }
{                                                       }
{ for Delphi 4, 5, 6                                    }
{ Version 2.0                                           }
{ Copyright (c) 2001 by Immo Wache                      }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - Turbo Pascal Version 7.0                          }
{     Turbo Vision Unit                                 }
{     Copyright (c) 1992 Borland International          }
{     www: http://www.borland.com                       }
{   - Virtual Pascal v2.1                               }
{     Copyright (C) 1996-2000 vpascal.com               }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/clx/wq/vi/ViHistList.pas,v 1.2 2002/10/27 22:25:18 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: ViHistList.pas,v $
  Revision 1.2  2002/10/27 22:25:18  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
{
  Version history:
    IWA 2001-05-24 Version 2.0.1.0 released
}

unit ViHistList;

{$X+,I-}

interface

uses
  Classes;

type
  TViHistoryList = class(TObject)
  public
    procedure Clear;
    destructor Destroy; override;
    procedure Add(Id: Integer; const Str: string);
    function Count(Id: Integer): Word;
    function Str(Id, Index: Integer): string;
    constructor Create;
    procedure LoadFromStream(Stream: TStream);
    procedure SaveToStream(Stream: TStream);
  end;

var
  ViHistoryList: TViHistoryList;  

implementation

procedure TViHistoryList.Clear;
begin
end;

destructor TViHistoryList.Destroy;
begin
  inherited Destroy;
end;

procedure TViHistoryList.Add(Id: Integer; const Str: string);
begin
  if Str = '' then Exit;
(*
  StartId(Id);

  { Delete duplicates }
  AdvanceStringPointer;
  while CurString <> nil do
  begin
    if Str = CurString^ then DeleteString;
    AdvanceStringPointer;
  end;

  InsertString(Id, Str);
*)
end;

function TViHistoryList.Count(Id: Integer): Word;
begin
(*
  StartId(Id);
  Count := 0;
  AdvanceStringPointer;
  while CurString <> nil do
  begin
    Inc(Count);
    AdvanceStringPointer;
  end;
  HistoryCount := Count;
*)
  Result := 0;  
end;

function TViHistoryList.Str(Id, Index: Integer): string;
begin
(*
  StartId(Id);
  for I := 0 to Index do AdvanceStringPointer;
  if CurString <> nil then
    HistoryStr := CurString^ else
    HistoryStr := '';
*)
  Result := '';
end;

constructor TViHistoryList.Create;
begin
  inherited Create;
end;

procedure TViHistoryList.LoadFromStream(Stream: TStream);
begin
(*
  S.Read(Size, SizeOf(Word));
  S.Read(HistoryBlock^, Size);
  HistoryUsed := Longint(HistoryBlock) + Size;
*)
end;

procedure TViHistoryList.SaveToStream(Stream: TStream);
begin
(*
  Size := HistoryUsed - Longint(HistoryBlock);
  S.Write(Size, SizeOf(Word));
  S.Write(HistoryBlock^, Size);
*)
end;

initialization
  ViHistoryList := TViHistoryList.Create;

finalization
  ViHistoryList.Free;
  ViHistoryList := nil;

end.
