
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (clx/vi)      }
{ WDosScreens.pas                                       }
{                                                       }
{ for Delphi 4, 5, 6                                    }
{ Version 2.0                                           }
{ Copyright (c) 2001 by Immo Wache                      }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - WDOSX DOS Extender                                }
{     Copyright (c) 1996, 1998, Michael Tippach         }
{     e-mail: mtippach@gmx.net                          }
{     www: http://www.wuschel.demon.co.uk               }
{     Realeased under the terms of the WDOSX            }
{     license agreement.                                }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/clx/wq/vi/wdosx/WDosScreens.pas,v 1.3 2002/10/27 22:25:25 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: WDosScreens.pas,v $
  Revision 1.3  2002/10/27 22:25:25  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
unit WDosScreens;

interface

uses
  {WDosCheck,} Windows, ViTypes;

var
  TextAttr: Byte;
  WindMin, WindMax: Word;
  OutHandle, InHandle: THandle;
  CrtInited: Boolean;
  DefCursorSize: Longint;
  ScreenWidth: Byte;
  ScreenHeight: Byte;

procedure InitCrt;
procedure DoneCrt;
function GetCursorSize: Longint;
procedure SetCursorSize(Size: Longint);
procedure CursorOn;
procedure CursorOff;
procedure CursorBig;
procedure CursorNorm;
procedure WriteScr(var Src: TScr; rCoordAttr: Boolean);
procedure ClrScr;
procedure SetTextMode(Mode: Word);
function GetTextMode: Word;
procedure GotoXY(X, Y: Byte);
function WhereX: Byte;
function WhereY: Byte;



implementation

var
  IsEGA: Boolean;
  CurrentPage: Byte;
  NormAttr: Byte;
  LastMode: Word;
  CheckSnow: Boolean;
  CheckBreak: Boolean;
  CheckEOF: Boolean;
  DirectVideo: Boolean;

procedure InitCrt;
begin
  CrtInited := True;
end;

procedure DoneCrt;
begin
  CrtInited := False;
end;

function GetCursorSize: Longint;
var
  CursorInfo: TConsoleCursorInfo;
begin
  Getconsolecursorinfo(OutHandle, CursorInfo);
  Result := CursorInfo.dwSize;
end;

procedure SetCursorSize(Size: Longint);
var
  CursorInfo: TConsoleCursorInfo;
begin
  Getconsolecursorinfo(OutHandle, CursorInfo);
  CursorInfo.dwSize := Size;
  CursorInfo.bVisible := True;
  Setconsolecursorinfo(OutHandle, CursorInfo);
end;

procedure CursorOn;
begin
  SetCursorSize(12);
end;

procedure CursorOff;
asm
    push ebx
    mov ah,01h
    mov ch,20h
    mov cl,00h
    int 10h
    pop ebx
end;

procedure CursorBig;
begin
  SetCursorSize(99);
end;

procedure CursorNorm;
begin
  SetCursorSize(12);
end;

procedure WriteScr(var Src: TScr; rCoordAttr: Boolean);
var
  Y: Integer;
  Dest: Pointer;
  Offs: Integer;
  Size: Integer;
begin
  with Src do
  begin
    for Y := Y1 - 1 to Y2 - 1 do
    begin
      Dest := Pointer($B8000 + (X1 - 1) * 2 + Y * 160);
      Size := (X2 - X1 + 1) * 2;
      Offs := (Y - Y1 + 1) * 80;
      Move(Data[Offs], Dest^, Size);
    end;
    if rCoordAttr then
    begin
      GotoXY(OldX, OldY);
      TextAttr := OldAttr;
    end;
  end;
end;

procedure ClrScr;
asm
    push ebx
    mov ax,600h
    mov bh,textattr
    mov cx,windmin
    mov dx,windmax
    push ds	{there're some bugs...          }
    push ebp	{see Ralf Brown's Interrupt list}
    int 10h
    pop ebp
    pop ds
    mov bh, CurrentPage
    mov dx,windmin
    mov ah,2
    int 10h
    pop ebx
end;

procedure SetTextMode(Mode: Word);
begin
  asm
    push ebx
    mov ax, Mode
    test ah,ah
    jz @@1
    cmp isega,true
    jnz @@4

@@1:
    cmp al,4
    jc @@2
    cmp al,7
    jnz @@4

@@2:
    mov ecx,eax
    sub ah,ah
    int 10h
    mov ah,0fh
    int 10h
    cmp cl,al
    jnz @@4
    mov CurrentPage,bh
    mov ax, Mode
    mov LastMode, ax
    test ah,ah
    jz @@3
    mov ax,1112h
    sub bl,bl
    int 10h

@@3:
{update screen window size}
    mov windmin,0
    mov al,ds:[44ah]
    mov ah,ds:[484h]
    mov windmax,ax
    mov ScreenWidth, AL
    inc AH
    mov ScreenHeight, AH
{update textattr}
    mov bh, CurrentPage
    mov ah,8
    int 10h
    mov textattr,ah

@@4:
    pop ebx
  end;  
end;

function GetTextMode: Word;
begin
  Result := LastMode;
end;

procedure GotoXY(X, Y: Byte);
asm
   {check if in current window, ignore if not}
    push ebx
    mov dh,Y
    mov dl,X
    mov ax,windmin
    dec dl
    dec dh
    add dl,al
    add dh,ah
    mov ax,windmax
    cmp dl,al
    ja @@1
    cmp dh,ah
    ja @@1
    mov bh, CurrentPage
    mov ah,2
    int 10h
@@1:
    pop ebx
end;

function WhereX: Byte;
asm
    push ebx
    mov bh, CurrentPage
    mov ah,3
    int 10h
    sub dl,byte ptr [offset windmin]
    inc dl
    mov Result,dl
    pop ebx
end;

function WhereY: Byte;
asm
    push ebx
    mov bh, CurrentPage
    mov ah,3
    int 10h
    sub dh,byte ptr [offset windmin + 1]
    inc dh
    mov Result,dh
    pop ebx
end;

{******************** private functions and procedures ***********************}

var
  chkm_rest: Boolean = False;
  chkm_x: Byte = 255;
  chkm_y: Byte = 255;
  chkm_donothing: Boolean = False;

function max_x: Byte;
var X: Byte;
begin
  asm
    mov al,ds:[44ah]
    dec al
    mov x,al
  end;
  max_x := X;
end;

function max_y: Byte;
var Y: Byte;
begin
  asm
    mov al,ds:[484h]
    mov y,al
  end;
  max_y := Y;
end;

procedure put_one(C: Byte);
begin
  asm
    push ebx

    mov ah,3
    mov bh, CurrentPage
    int 10h
    mov chkm_x,dl
    mov chkm_y,dh
    mov bl,textattr
    mov bh, CurrentPage
    mov ah,9
    mov al,c
    mov cx,1
    int 10h

{update cursor position}
    mov ah,3
    int 10h
{start with X}
    inc dl
    cmp dl,byte ptr [offset windmax]
    jna @@1
    inc dh
    mov dl,byte ptr [offset windmin]

@@1:
{now check Y}
    cmp dh,byte ptr [offset windmax+1]
    jna @@2
{have to scroll the window}
    dec dh
    push edx
    mov cx,windmin
    mov dx,windmax
    mov bh,textattr
    mov ax,0601h
    push ds
    push ebp
    int 10h
    pop ebp
    pop ds
    pop edx

@@2:
{set new cursor pos.}
    mov bh, CurrentPage
    mov ah,2
    int 10h
    pop ebx
  end;
end;

procedure nuke_one;
begin
  if WhereX > 1 then
  begin
    asm
      push ebx
      mov bh, CurrentPage
      mov ah,3
      int 10h
      dec dl
      mov chkm_x,dl
      mov chkm_y,dh
      mov ah,2
      int 10h
      mov ax,920h
      mov bl,textattr
      mov cx,1
      int 10h
      pop ebx
    end;
  end;
end;

procedure put_cr; //checkmouse is not needed, 'cause there's no screen write
begin
  asm
    push ebx
    mov bh, CurrentPage
    mov ah,3
    int 10h
    mov dl,byte ptr [offset windmin]
    mov ah,2
    int 10h
    pop ebx
  end;
end;

procedure put_lf; //checkmouse is only needed when scrolling
begin
  asm
    push ebx
    mov bh, CurrentPage
    mov ah,3
    int 10h
    inc dh
    cmp dh,byte ptr [offset windmax+1]
    jna @@1
{have to scroll the window}
    dec dh
    push edx
    mov cx,windmin
    mov dx,windmax
    mov bh,textattr
    mov ax,0601h
    push ds
    push ebp
    int 10h
    pop ebp
    pop ds
    pop edx
@@1:
{set new cursor pos.}
    mov bh, CurrentPage
    mov ah,2
    int 10h
    pop ebx
  end;
end;

initialization
  asm
    push ebx
{get videomode info, check for supported videomode}
    mov ah,0fh
    int 10h
    cmp al,4
    jc @@1
    cmp al,smMono
    jz @@1
    mov ax,3
    int 10h
    mov ah,0fh
    int 10h
    cmp al,smCO80
    jz @@1
    mov ax,7
    int 10h
    mov ah,0fh
    int 10h
    cmp al,smMono
    jz @@1
{abort if no suitable videomode, this one is for the paranoid}
@@00:
    mov	eax,4cffh
    int	21h
@@1:
    mov CurrentPage, bh
    push eax
    mov ah,12h
    mov bx,0ff10h
    int 10h
    inc bh
    mov isega,true
    jnz @@2
{no ega}
    mov isega,false

@@2:
    mov bl,ds:[484h]
    cmp bl,18h
    seta bh
    pop eax
    cmp isega,true
    jz @@3
    sub bh,bh

@@3:
    xchg ah,bh
    mov lastmode,ax

    mov checksnow,true
    cmp al,1
    jz @@4
    cmp al,3
    jz @@4
    mov checksnow,false

@@4:
    xchg bl,bh
    mov windmax,bx
    mov windmin,0
    mov ScreenWidth, BL
    inc BH
    mov ScreenHeight, BH

{read attribute at cursor position}
    mov bh, CurrentPage
    mov ah,8
    int 10h
    mov textattr,ah
    mov normattr,ah
{set defaults}
    mov directvideo,true
    mov checkbreak,true
    mov checkeof,false

{hook into int 21 to trap console reads/writes                            }
{I'd like to apologize to everyone for that mess, especially if you're not}
{an all- day ASM coder. It works, anyway.                                 }

{get old interrupt vector}
    mov ax,0204h
    mov bl,21h
    int 31h
    jc @@00
    mov dword ptr ds:[offset @@21+1],edx
    mov word ptr ds:[offset @@21+5],cx

{set new one}

    mov cx,cs
    mov edx,offset @@hook
    inc eax
    int 31h
    jc @@00

    jmp @@5

@@hook:
    cmp ah,3fh
    jz @@tread
    cmp ah,40h
    jz @@twrite

@@21:
    db  0eah {jmp far}
    dd	0
    dw  0

@@tread:

    test bx,bx
    jnz @@21
    sub	eax,eax
    pushad


@@r00:
    sub ah,ah
    int 16h

    cmp al,20h
    jnc @@r04

{is control char}
    cmp al,8
    jnz @@r01

    call nuke_one
    cmp dword ptr [esp+28],0
    jz @@r00
    dec dword ptr [esp+28]
    jmp @@r00

@@r01:
    cmp al,13
    jz @@r03
    cmp al,27
    jnz @@r00


@@r02:
    cmp dword ptr [esp+28],0
    jz @@r00
    call nuke_one
    dec dword ptr [esp+28]
    jmp @@r02

@@r04:
    mov ebx,[esp+28]
    inc ebx
    inc ebx
    cmp ebx,[esp+24]
    jnc @@r00
    dec ebx
    dec ebx
    inc dword ptr [esp+28]
    add ebx,[esp+20]
    mov [ebx],al
    call put_one
    jmp @@r00

@@r03:
{all done}
    mov ebx,[esp+28]
    add dword ptr [esp+28],2
    add ebx,[esp+20]
    mov word ptr [ebx],0a0dh
    call put_cr
    call put_lf
    popad
    and byte ptr [esp+8],0feh
    iretd

@@twrite:
    cmp bx,1
    jnz @@21

    push ebx
    test ecx,ecx
    jz @@w01
    push edx
    push ecx

@@w00:
    mov al,[edx]
    inc edx
    push edx
    push ecx
    call @@onscreen
    pop ecx
    pop edx
    loop @@w00

    pop ecx
    pop edx

@@w01:
    mov eax,ecx
    pop ebx
    and byte ptr [esp+8],0feh
    iretd

@@onscreen:
    cmp al,7
    jnz @@o1
    mov ah,0eh
    int 10h
    retn

@@o1:
    cmp al,8
    jnz @@o2
    call nuke_one
    retn

@@o2:
    cmp al,10
    jnz @@o3
    call put_lf
    retn

@@o3:
    cmp al,13
    jnz @@o4
    call put_cr
    retn

@@o4:

    call put_one
    retn

@@5:
    pop ebx
  end;

  OutHandle := Getstdhandle(Std_output_handle);
  InHandle := Getstdhandle(Std_input_handle);
  DefCursorSize := GetCursorSize;
  CrtInited := False;
end.

