{ let's manipulate the text-mode (8x16) font }

unit textchar;

interface

{ after this call the text-mode character set will be available for read/write
  at $A0000 }
procedure EnableCharset;

{ restores the normal state of the vga card, must be called as soon as
  possible after EnableCharset }
procedure DisableCharset;

{ replaces the current font with the specified one, `src' must point to a
  4096 bytes long area }
procedure SetCharset(src:pointer);

implementation

uses WDosPorts;

procedure EnableCharset;
begin
  portw[$3ce]:=$0406;
  portw[$3c4]:=$0402;
  portw[$3c4]:=$0704;
  portw[$3ce]:=$0204;
  portw[$3ce]:=$0005;
end;

procedure DisableCharset;
begin
  portw[$3ce]:=$0e06;
  portw[$3ce]:=$0004;
  portw[$3ce]:=$1005;
  portw[$3c4]:=$0302;
  portw[$3c4]:=$0304;
end;

procedure SetCharset(src:pointer);
var
  i:integer;
begin
  EnableCharset;
  for i:=0 to 255 do
    move(pointer(longint(src)+i*16)^,pointer($A0000+i*32)^,16);
  DisableCharset;
end;

end.
