
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (rtl)         }
{ TCP/IP Stack for native DOS Packet drivers            }
{ WDosPktDrvWinNT.pas                                   }
{                                                       }
{ for Delphi 4-7                                        }
{ Version 2.2.0                                         }
{ Copyright (c) 2003 by Diego De Marco                  }
{ e-mail: ddemarco@dpsautomation.com                    }
{                                                       }
{ Contributor(s):                                       }
{   Immo Wache immo.wache@dwp42.org                     }
{   wwww:      http://www.dwp42.org                     }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{*******************************************************}

{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/wdosx/WDosPktDrvWinNT.pas,v 1.1 2003/05/08 18:59:57 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: WDosPktDrvWinNT.pas,v $
  Revision 1.1  2003/05/08 18:59:57  iwache
  TCP/IP Stack for native DOS Packet drivers by Diego De Marco added.

  ----------------------------------------------------------------------------
}
unit WDosPktDrvWinNT;

{$X+}

interface

uses
  SysUtils, WDosNetwork, WDosPorts;

type
  { Adapter Object }
  TWindowsAdapter = class(TNetworkAdapter)
  private
  protected
    procedure CheckStatus; override;
    function GetPacket(var Packet: TEthernetPacket): Boolean; override;
    function IntAddProtocol(TypeLen: WORD): Boolean; override;
    function IntRemoveProtocol(TypeLen: WORD): Boolean; override;
  public
    function GetAddress(var Addr: TEthernetAddress): Boolean; override;
    function SendPkt(Buffer: Pointer; BufLen: Word): Boolean; override;
  end;

implementation

function GetDS: WORD;
begin
  asm
		MOV Result, DS

  end;
end;

procedure TWindowsAdapter.CheckStatus;
var
  Buffer: array[0..1024] of char;
begin
  if (FStatus = asOk) then
  begin
    PortW[$300] := GetDS; { Selector }
    PortW[$302] := WORD(@Buffer); { Offset (Lo) }
    PortW[$304] := Cardinal(@Buffer) shr 16; { Offset (Hi) }
    PortW[$306] := SizeOf(Buffer); { Size = BufLen }
    Port[$309] := 0; { Get Info }
    if Port[$308] = 0 then
    begin
      FStatus := asOk;
      FAdapterName := StrPas(Buffer);
    end
    else
    begin
      FStatus := asError;
    end;
  end
  else
  begin
    FStatus := asError;
  end;
end;

function TWindowsAdapter.IntAddProtocol(TypeLen: WORD): Boolean;
begin
  Result := True;
end;

function TWindowsAdapter.IntRemoveProtocol(TypeLen: WORD): Boolean;
begin
  Result := True;
end;

function TWindowsAdapter.SendPkt(Buffer: Pointer; BufLen: Word): Boolean;
begin
  if (FStatus = asOk) then
  begin
    PortW[$300] := GetDS; { Selector }
    PortW[$302] := WORD(Buffer); { Offset (Lo) }
    PortW[$304] := Cardinal(Buffer) shr 16; { Offset (Hi) }
    PortW[$306] := BufLen; { Size = BufLen }
    Port[$309] := 3; { Send Packet }
    Result := (Port[$308] = 0);
  end
  else
  begin
    Result := False;
  end;
end;

function TWindowsAdapter.GetAddress(var Addr: TEthernetAddress): Boolean;
begin
  if FStatus = asOk then
  begin
    PortW[$300] := GetDS; { Selector }
    PortW[$302] := WORD(@Addr); { Offset (Lo) }
    PortW[$304] := Cardinal(@Addr) shr 16; { Offset (Hi) }
    PortW[$306] := 6; { Size = 6 }
    Port[$309] := 1; { Get MAC }
    Result := (Port[$308] = 0);
  end
  else
  begin
    Result := False;
  end;
end;

function TWindowsAdapter.GetPacket(var Packet: TEthernetPacket): Boolean;
begin
  if (FStatus = asOk) then
  begin
    PortW[$300] := GetDS; { Selector }
    PortW[$302] := WORD(@Packet); { Offset (Lo) }
    PortW[$304] := Cardinal(@Packet) shr 16; { Offset (Hi) }
    PortW[$306] := SizeOf(Packet); { Size = BufLen }
    Port[$309] := 2; { Get Packet }
    Result := (Port[$308] = 0) and (PortW[$306] > 0);
  end
  else
  begin
    Result := False;
  end;
end;

end.

