
{*******************************************************}
{                                                       }
{ DWPL Delphi WDosX and Cross Platform Library (rtl)    }
{ WDosTypes.pas                                         }
{                                                       }
{ for Delphi 6                                          }
{ Version 2.0                                           }
{ Copyright (c) 2002 by Team-DWP                        }
{ e-mail: team-dwp@dwp42.org                            }
{ www: http://www.dwp42.org                             }
{                                                       }
{ The initial developer of the code is                  }
{   Jason G Burgon jay@jayman.demon.co.uk               }
{                                                       }
{ Portions created by Jason G Burgon are                }
{ Copyright (C) 1994-2002 Jason G Burgon.               }
{                                                       }
{ Contributor(s):                                       }
{   none for now                                        }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ Licensees holding a valid Team-DWP No-Nonsense        } 
{ License for this Software may use this file in        }
{ accordance with such license, which appears in        }
{ the file license.txt that came with this software.    }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - Graphic Vision Unit                               }
{     Copyright (c) 1994-2001 Jason G Burgon            }
{     www: http://www.jayman.demon.co.uk                }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/wdosx/WDosTypes.pas,v 1.5 2003/01/04 16:35:01 lagocs Exp $
  ----------------------------------------------------------------------------

  $Log: WDosTypes.pas,v $
  Revision 1.5  2003/01/04 16:35:01  lagocs
  d4 support added

  Revision 1.4  2002/11/06 19:07:27  lagocs
  D5 fixes

  Revision 1.3  2002/10/27 22:53:12  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
unit WDosTypes;

{$H-}

interface

const

{ ASCII codes }

  asNull           = #0;
  asBell           = #7;
  asBackSpace      = #8;
  asTab            = #9;
  asLF             = #10;
  asCR             = #13;
  asEOF            = #26;
  asEscape         = #27;
  asSpace          = #32;
  asDelete         = #127;

{ VMT header size of a Delph-style Class }

  vmtClassHeaderSize = SizeOf(Pointer) * 0;

{ VMT header size of a Turbo Pascal style Object }

  vmtHeaderSize = SizeOf(Pointer) * 0;

{ Simple types }

type
{$ifdef ver100}
  LongWord= Cardinal;                 { Fundamental 32-bit unsigned integer }
  Int64   = packed record             { Fundamental 64-bit signed integer   }
              Lo: LongWord;
              Hi: Longint;
            end;
{$endif ver100}

 { Type conversion records }

  WordRec = packed record
    Lo, Hi: Byte;
  end;

  LongRec = packed record
    Lo, Hi: Word;
  end;

  PtrRec = packed record
    Ofs: Cardinal;
  end;

{ Simple pointer types }

  NearPtr   =  Pointer;
  FarPtr    =  packed record
    Ofs: LongWord;
    Seg: Word;
  end;
//  PPointer     = ^Pointer;
//  PByte        = ^Byte;
//  PShortInt    = ^ShortInt;
//  PSmallInt    = ^SmallInt;
//  PWord        = ^Word;
//  PInteger     = ^Integer;
//  PLongint     = ^Longint;
//  PCardinal    = ^Cardinal;
{$IFDEF VER130}
  PLongWord    = ^LongWord;
{$ENDIF}
{$IFDEF VER120}
  PLongWord    = ^LongWord;
{$ENDIF}
//  PInt64       = ^Int64;
  PFarPtr      = ^FarPtr;
//  PString      = ^ShortString;
//  PShortString = ^ShortString;
//  PBoolean     = ^Boolean;
//  PWordBool    = ^WordBool;
//  PLongBool    = ^LongBool;

{ Character set type }

  PCharSet = ^TCharSet;
  TCharSet = Set of Char;

{ Maximua and Minima }

const
   minInt     = Low(Integer);
   maxInt     = High(Integer);

   minCardinal= Low(Cardinal);
   maxCardinal= High(Cardinal);

   minByte    = Low(Byte);
   maxByte    = High(Byte);

   minSmallInt= Low(SmallInt);
   maxSmallInt= High(SmallInt);

   minLongint = Low(Longint);
   maxLongint = High(Longint);

   minLongWord= Low(LongWord);
   maxLongWord= High(LongWord);

   maxStrucSize= maxInt;

  { General arrays }

type
  PByteArray = ^TByteArray;
  TByteArray = packed array[0..maxStrucSize-1] of Byte;

  PWordArray = ^TWordArray;
  TWordArray = packed array[0..(maxStrucSize div SizeOf(Word))-1] of Word;

  PIntArray  = ^TIntArray;
  TIntArray  = packed array[0..(maxStrucSize div SizeOf(Integer))-1] of Integer;

  PLongArray = ^TLongArray;
  TLongArray = packed array[0..(maxStrucSize div SizeOf(Longint))-1] of Longint;

  PLongWordArray = ^TLongArray;
  TLongWordArray = packed array[0..(maxStrucSize div SizeOf(LongWord))-1] of LongWord;

  PCharArray = ^TCharArray;
  TCharArray = packed array[0..(maxStrucSize div SizeOf(Char))-1] of Char;

  PPtrArray  = ^PtrArray;
  PtrArray   = packed array [0..(maxStrucSize div SizeOf(Pointer))-1] of Pointer;

{ Comparison routines }

function Max(A, B: Integer): Integer;

function Min(A, B: Integer): Integer;

function MaxWord(A, B: Word): Word;

function MinWord(A, B: Word): Word;

function MaxCard(A, B: Cardinal): Cardinal;

function MinCard(A, B: Cardinal): Cardinal;

function MaxLong(A, B: Longint): Longint;

function MinLong(A, B: Longint): Longint;

{ Utilitity pointer routines }

function Segment(P: Pointer): Word; register;

function Offset(P: Pointer): Cardinal; register;

{ Return a pointer to an class-type object's VMT }

function GetVmt(AObject: TObject): Pointer; register;

{ Return the address of AObject's VmtIndex'th virtual method }
{ where VmtIndex = 0 = 1st non-TObject-defined method        }

function GetVirtualPtr(AObject: TObject; VmtIndex: Integer): Pointer; register;

function LongMake(Hi, Lo: Word): Longint; register;

implementation

{----------------------------- Comparison routines -------------------------}

function Max(A, B: Integer): Integer;
begin
  Max := B;
  if B < A
   then Max := A;
end;

function Min(A, B: Integer): Integer;
begin
  Min := B;
  if B > A
   then Min := A;
end;

function MaxWord(A, B: Word): Word;
begin
  Result := A;
  if B > A
   then Result := B;
end;

function MinWord(A, B: Word): Word;
begin
  Result := A;
  if B < A
   then Result := A;
end;

function MaxCard(A, B: Cardinal): Cardinal;
begin
  Result := A;
  if B > A
   then Result := B;
end;

function MinCard(A, B: Cardinal): Cardinal;
begin
  Result := A;
  if B < A
   then Result := A;
end;

function MaxLong(A, B: Longint): Longint;
begin
  Result := A;
  if B > A
   then Result := B;
end;

function MinLong(A, B: Longint): Longint;
begin
  Result := A;
  if B < A
   then Result := A;
end;

{------------------------------ Longint routines ---------------------------}

function LongMake(Hi, Lo: Word): Longint; register;
asm
            shld   eax,edx,16
end;

{------------------------- Utilitity pointer routines ----------------------}

function GetVmt(AObject: TObject): Pointer; register;
asm
            mov eax,[eax]
end;

function GetVirtualPtr(AObject: TObject; VmtIndex: Integer): Pointer;
asm
            mov   ecx,[eax]
            mov   eax,[ecx + (edx * type Pointer) + vmtClassHeaderSize]
end;

function Segment(P: Pointer): Word; register
asm
            mov eax,ds
end;

function Offset(P: Pointer): Cardinal;
begin
  Result := PtrRec(P).Ofs;
end;

end.

