
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (rtl)         }
{ WDosWfseStreams.pas                                   }
{                                                       }
{ for Delphi 4, 5, 6                                    }
{ Version 2.0                                           }
{ Copyright (c) 2001 by Immo Wache                      }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - WDOSX DOS Extender                                }
{     Copyright (c) 1996, 1998, Michael Tippach         }
{     e-mail: mtippach@gmx.net                          }
{     www: http://www.wuschel.demon.co.uk               }
{     Realeased under the terms of the WDOSX            }
{     license agreement.                                }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/wdosx/WDosWfseStreams.pas,v 1.2 2002/10/27 22:53:12 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: WDosWfseStreams.pas,v $
  Revision 1.2  2002/10/27 22:53:12  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
unit WDosWfseStreams;

interface

uses
  WDosCheck, Windows, SysUtils, Classes;

type

{ TWfseStream class }

  TWfseStream = class (TStream)
  private
    FHandle: Integer;
  public
    constructor Create(const FileName: string);
    destructor Destroy; override;
    function Read(var Buffer; Count: Longint): LongInt; override;
    function Seek(Offset: Longint; Origin: Word): LongInt; override;
    function Write(const Buffer; Count: Longint): LongInt; override;
    property Handle: Integer read FHandle;
  end;

function WfseFileSeek(Handle, AOffset, Origin: Integer): Integer;

var
  WfseVersion: Integer =0;

implementation

uses
  RTLConsts, WDosResStrings;

var
  DataSelector: LongInt;

function WfseFileOpen(FileName: PChar): Integer; assembler;
asm
        MOV     EDX,EAX
        MOV     EAX,3D00FFFDH
        INT     21H
        JNC     @@0
        SBB     EAX,EAX
  @@0:
end;

procedure WfseFileClose(FHandle: Integer); assembler;
asm
        PUSH    EBX
        MOV     EBX,EAX
        MOV     EAX,3E00FFFDH
        INT     21H
        POP     EBX
end;

function WfseFileRead(Handle: Integer; var Buffer; Count: LongWord): Integer;
assembler;
asm
        PUSH    EBX
        MOV     EBX,EAX
        MOV     EAX,3F00FFFDH
        INT     21H
        JNC     @@0
        SBB     EAX,EAX
  @@0:
        POP     EBX
end;

function WfseFileSeek(Handle, AOffset, Origin: Integer): Integer; assembler;
asm
        PUSH    EBX
        MOV     EBX,EAX
        MOV     EAX,ECX
        AND     EAX,03H
        CMP     EAX,03H
        JNZ     @@0
        XOR     EAX,EAX
  @@0:
        SHL     EAX,10H
        ADD     EAX,4200FFFDH
        MOV     ECX,EDX
        SHR     ECX,10H
        INT     21H
        JNC     @@1
        SBB     EAX,EAX
        JNE     @@2
  @@1:
        SHL     EDX,10H
        AND     EAX,0FFFFH
        ADD     EAX,EDX
  @@2:
        POP     EBX
end;

{
********************************* TWfseStream **********************************
}
constructor TWfseStream.Create(const FileName: string);
begin
  FHandle := WfseFileOpen(PChar(FileName));
  if FHandle <0 then
    raise EFOpenError.CreateResFmt(@SFOpenError, [FileName]);
end;

destructor TWfseStream.Destroy;
begin
  if FHandle >=0 then WfseFileClose(FHandle);
  inherited Destroy;
end;

function TWfseStream.Read(var Buffer; Count: Longint): LongInt;
begin
  Result := WfseFileRead(FHandle, Buffer, Count);
  if Result <0 then Result := 0;
end;

function TWfseStream.Seek(Offset: Longint; Origin: Word): LongInt;
begin
  Result := WfseFileSeek(FHandle, Offset, Origin);
end;

function TWfseStream.Write(const Buffer; Count: Longint): LongInt;
begin
  raise EStreamError.CreateRes(@SCantWriteWfseStreamError);
  Result :=0;
end;

var
  Ident: LongWord;
  Carry: Integer;

initialization
  asm
        PUSH    EBX
        MOV     EAX,0000FFFDH
        INT     21H
        MOV     Ident,EAX
        MOV     WfseVersion,EBX
        SBB     EAX,EAX
        MOV     Carry,EAX
        POP     EBX
        MOV	DataSelector,DS
  end;
  if (Ident <>$57465345) { 'WFSE' } or (Carry <>0) then
  begin
    Writeln(SCantInitializeWfse);
    Halt(1);
  end;

end.
